"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var minilog = require("minilog");
var yargs = require("yargs");
var createConfig_1 = require("./createConfig");
var executor_1 = require("./executor");
var init_1 = require("./init");
minilog.enable();
var logger = minilog('spin');
try {
    var argv = yargs
        .command('build', 'compiles package for usage in production')
        .command('watch', 'launches package in development mode with hot code reload')
        .command('exp', 'launches server for exp and exp tool')
        .command('test [mocha-webpack options]', 'runs package tests')
        .demandCommand(1, '')
        .option('c', {
        describe: 'Specify path to config file',
        type: 'string'
    })
        .option('verbose', {
        alias: 'v',
        default: false,
        describe: 'Show generated config',
        type: 'boolean'
    })
        .version(require('../package.json').version)
        .argv;
    var cmd = argv._[0];
    var config = void 0;
    if (argv.help && cmd !== 'exp') {
        yargs.showHelp();
    }
    else {
        var cwd = process.cwd();
        if (cmd === 'watch' || cmd === 'build' || cmd === 'test' || cmd === 'exp') {
            config = createConfig_1.default(cwd, cmd, argv);
        }
        if (cmd === 'init') {
            init_1.default();
        }
        else {
            executor_1.default(cmd, argv, config.builders, config.spin);
        }
    }
}
catch (e) {
    logger.error(e.stack);
}
//# sourceMappingURL=cli.js.map