"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var JSRuleFinder_1 = require("./shared/JSRuleFinder");
var ES6Plugin = (function () {
    function ES6Plugin() {
    }
    ES6Plugin.prototype.configure = function (builder, spin) {
        if (builder.stack.hasAll(['es6', 'webpack'])) {
            if (builder.stack.hasAny('es6') && !builder.stack.hasAny('dll')) {
                builder.config = spin.merge({
                    entry: {
                        index: ['babel-polyfill']
                    }
                }, builder.config);
            }
            var jsRuleFinder = new JSRuleFinder_1.default(builder);
            var jsRule = jsRuleFinder.findAndCreateJSRule();
            jsRule.exclude = /node_modules/;
            jsRule.use = {
                loader: spin.require.resolve('babel-loader'),
                options: {
                    babelrc: false,
                    cacheDirectory: spin.dev,
                    compact: !spin.dev,
                    presets: [
                        spin.require.resolve('babel-preset-react'),
                        [spin.require.resolve('babel-preset-env'), { modules: false }],
                        spin.require.resolve('babel-preset-stage-0')
                    ].concat(spin.dev ? [] : [[spin.require.resolve('babel-preset-minify'), { mangle: false }]]),
                    plugins: [
                        spin.require.resolve('babel-plugin-transform-runtime'),
                        spin.require.resolve('babel-plugin-transform-decorators-legacy'),
                        spin.require.resolve('babel-plugin-transform-class-properties')
                    ],
                    only: jsRuleFinder.extensions.map(function (ext) { return '*.' + ext; })
                }
            };
        }
    };
    return ES6Plugin;
}());
exports.default = ES6Plugin;
//# sourceMappingURL=ES6Plugin.js.map